/*
**      $VER: SP_RecogSubs.c 3.4 (22.1.97)
**
**      SPObject module binding and library initialization
**
**      (C) Copyright 1994-97 Andreas R. Kleinert
**      All Rights Reserved.
*/

#include "spobject.h"

#include <exec/execbase.h>
#include <exec/resident.h>
#include <exec/initializers.h>

ULONG __saveds __stdargs SPLI_OpenLibs(void);
void  __saveds __stdargs SPLI_CloseLibs(void);
void  __saveds __stdargs SPLI_InitSPOList(void);

struct ExecBase      *SysBase               = N;
struct DosLibrary    *DOSBase               = N;
struct IntuitionBase *IntuitionBase         = N;
struct GfxBase       *GfxBase               = N;
struct Library       *UtilityBase           = N;
struct XpkBase       *XpkBase               = N;

#define VERSION  3
#define REVISION 4

char __aligned SVLibName [] = "SPO.spobject";
char __aligned SVLibID   [] = "SPO 3.3 (22.1.97)";
char __aligned Copyright [] = "(c) 1994-97 by Andreas R. Kleinert";

extern ULONG InitTab[];

extern APTR EndResident; /* below */

struct Resident ROMTag =
{
 RTC_MATCHWORD,
 &ROMTag,
 &EndResident,
 RTF_AUTOINIT,
 VERSION,
 NT_LIBRARY,
 0,
 &SVLibName[0],
 &SVLibID[0],
 &InitTab[0]
};

APTR EndResident;

struct MyDataInit
{
 UWORD ainit1; UWORD binit1; UWORD ln_type;
 UBYTE ainit2; UBYTE binit2; ULONG ln_name2;
 UWORD ainit3; UWORD binit3; UWORD lib_flags;
 UWORD ainit4; UWORD binit4; UWORD lib_version;
 UWORD ainit5; UWORD binit5; UWORD lib_revision;
 UBYTE ainit6; UBYTE binit6; ULONG lib_idstring2;
 ULONG end;
} DataTab =
{
 INITBYTE(OFFSET(Node,         ln_Type),      NT_LIBRARY),
 0x80, (UBYTE) OFFSET(Node,    ln_Name),      (ULONG) &SVLibName[0],
 INITBYTE(OFFSET(Library,      lib_Flags),    LIBF_SUMUSED|LIBF_CHANGED),
 INITWORD(OFFSET(Library,      lib_Version),  VERSION),
 INITWORD(OFFSET(Library,      lib_Revision), REVISION),
 0x80, (UBYTE) OFFSET(Library, lib_IdString), (ULONG) &SVLibID[0],
 (ULONG) 0
};

ULONG __saveds __stdargs SPLI_OpenLibs(void)
{
 SysBase = (*((struct ExecBase **) 4));


 if(!FindSemaphore("splib_pre-init")) return(FALSE);

 DOSBase = (APTR) OpenLibrary("dos.library", 37);
 if(!DOSBase) return(FALSE);

 IntuitionBase = (APTR) OpenLibrary("intuition.library", 37);
 if(!IntuitionBase) return(FALSE);

 GfxBase = (APTR) OpenLibrary("graphics.library", 37);
 if(!GfxBase) return(FALSE);

 UtilityBase = (APTR) OpenLibrary("utility.library", 37);
 if(!UtilityBase) return(FALSE);

 return(TRUE);
}

void __saveds __stdargs SPLI_CloseLibs(void)
{
 if(DOSBase)               CloseLibrary((APTR) DOSBase);
 if(IntuitionBase)         CloseLibrary((APTR) IntuitionBase);
 if(GfxBase)               CloseLibrary((APTR) GfxBase);
 if(UtilityBase)           CloseLibrary((APTR) UtilityBase);
 if(XpkBase)               CloseLibrary((APTR) XpkBase);
}

void __saveds __stdargs SPLI_InitSPOList(void)
{
 struct SPO_ObjectNode *spo_node = N;

 SPObjectBase->spb_SPObject = N;

 if(FindSemaphore("splib_post-init"))
  {
   struct SuperPlayBase *SuperPlayBase = (APTR) OpenLibrary("superplay.library", 5);

   if(SuperPlayBase)
    {
     SPObjectBase->spb_SPObject = (APTR) FindName((APTR) &SuperPlayBase->spb_SPObjectList, "SPO.spobject");

     CloseLibrary((APTR) SuperPlayBase);
    }
  }else
  {
   spo_node = AllocVec(sizeof(struct SPO_ObjectNode), (MEMF_CLEAR|MEMF_PUBLIC));

   if(!spo_node) return;

   SPObjectBase->spb_SPObject = spo_node;

   ((struct Node *)spo_node)->ln_Type = NT_UNKNOWN;
   ((struct Node *)spo_node)->ln_Pri  = -1;
   ((struct Node *)spo_node)->ln_Name = N;

   spo_node->spo_Version = LibVer(SPObjectBase);
   spo_node->spo_ObjectType = SPO_OBJECTTYPE_SAMPLE;

   strcpy(spo_node->spo_FileName, "SPO.spobject");

   strcpy(spo_node->spo_TypeID, "SPO Sample");
   spo_node->spo_TypeCode = N;                /* set by superplay.library */

   spo_node->spo_SubTypeNum = 1;

   strcpy(spo_node->spo_SubTypeID[0], " ");

   spo_node->spo_SubTypeCode[0] = N;          /* set by superplay.library */

   spo_node->spo_BackgroundReplay = TRUE;
  }
}
