/*
**      $VER: spobject.h 3.3 (4.1.97)
**
**      SPObject definitions
**
**      (C) Copyright 1994-97 Andreas R. Kleinert
**      All Rights Reserved.
*/

#ifndef SPOBJECT_H
#define SPOBJECT_H

#define __USE_SYSBASE

#ifndef SUPERPLAY_SUPERPLAYBASE_H
#include <superplay/superplaybase.h>
#endif  /* SUPERPLAY_SUPERPLAYBASE_H */

#ifndef SPOBJECTS_SPOBJECTBASE_H
#include <spobjects/spobjectbase.h>
#endif  /* SPOBJECTS_SPOBJECTBASE_H

#ifndef INTUITION_INTUITIONBASE_H
#include <intuition/intuitionbase.h>
#endif /* INTUITION_INTUITIONBASE_H */

#ifndef EXEC_MEMORY_H
#include <exec/memory.h>
#endif /* EXEC_MEMORY_H */

#ifndef EXEC_LISTS_H
#include <exec/lists.h>
#endif /* EXEC_LISTS_H */

#ifndef EXEC_INTERRUPTS_H
#include <exec/interrupts.h>
#endif /* EXEC_INTERRUPTS_H */

#ifndef LIBRARIES_IFFPARSE_H
#include <libraries/iffparse.h>     /* for MAKE_ID macro : I'm lazy ... */
#endif /* LIBRARIES_IFFPARSE_H */

#include <xpk/xpk.h>
#include <clib/xpkmaster_protos.h>
#include <pragma/xpkmaster_lib.h>

#include <proto/exec.h>
#include <proto/dos.h>
#include <proto/intuition.h>
#include <proto/utility.h>

#include "SP_SampleListSubs.h"
#include "st.h"
#include "spobject_api.h"


/* macros */

#define ID_PP20 MAKE_ID('P','P','2','0')
#define ID_XPKF MAKE_ID('X','P','K','F')


/* *************************************************** */
/* *                                                 * */
/* * SP_PlaySubs.c : ...                             * */
/* *                                                 * */
/* *************************************************** */

 /* Global Variables for SP_Player.a */

extern APTR  __far ST_Module;
extern ULONG __far ST_Len;
extern ULONG __far ST_RunState;


/* *************************************************** */
/* *                                                 * */
/* * SP_Player.a : ...                               * */
/* *                                                 * */
/* *************************************************** */

extern void __asm __saveds ST_UnLoadModule(void);
extern void __asm __saveds ST_Start(void);
extern void __asm __saveds ST_Stop(void);
extern long __asm __saveds ST_IsPlaying(void);


/* *************************************************** */
/* *                                                 * */
/* * Additional Base Declarations                    * */
/* *                                                 * */
/* *************************************************** */

extern struct SPObjectBase  *SPObjectBase;

extern struct ExecBase      *SysBase;
extern struct DosLibrary    *DOSBase;
extern struct IntuitionBase *IntuitionBase;
extern struct Library       *UtilityBase;
extern struct XpkBase       *XpkBase;


 /* structures for File-Handling */

struct SPObjectHandle                   /* STRICTLY PRIVATE */
{
 BPTR                ah_filehandle_source;
 BPTR                ah_filehandle_dest;

 char               *ah_ReadName;
 char               *ah_WriteName;

 struct Window      *ah_ReqIOWindow;

 ULONG               ah_FileType;           /* SP_FILETYPE_ ... */
 ULONG               ah_Type;               /* SP_SUBTYPE_  ... */
 ULONG               ah_WriteMode;          /* SP_SUBTYPE_  ... */
 ULONG               ah_Medium;             /* SPO_MEDIUM_  ... */

 APTR                ah_STModule;
 ULONG               ah_STLen;
 ULONG               ah_STRunState;

 struct SPO_SampleList *ah_SampleList;
};

#endif /* SPOBJECT_H */
